package controller

import (
	"fmt"
	"strconv"
	"strings"
	"time"

	"be.ems/src/framework/i18n"
	"be.ems/src/framework/reqctx"
	"be.ems/src/framework/resp"
	"be.ems/src/framework/utils/file"
	"be.ems/src/framework/utils/parse"
	"be.ems/src/modules/system/model"
	"be.ems/src/modules/system/service"

	"github.com/gin-gonic/gin"
)

// 实例化控制层 SysDictDataController 结构体
var NewSysDictData = &SysDictDataController{
	sysDictDataService: service.NewSysDictData,
	sysDictTypeService: service.NewSysDictType,
}

// 字典类型对应的字典数据信息
//
// PATH /system/dict/data
type SysDictDataController struct {
	sysDictDataService *service.SysDictData // 字典数据服务
	sysDictTypeService *service.SysDictType // 字典类型服务
}

// 字典数据列表
//
// GET /list
//
//	@Tags			system/dict/data
//	@Accept			json
//	@Produce		json
//	@Param			dictLabel	query		string	false	"dictLabel"
//	@Param			pageNum		query		number	true	"pageNum"	default(1)
//	@Param			pageSize	query		number	true	"pageSize"	default(10)
//	@Success		200			{object}	object	"Response Results"
//	@Security		TokenAuth
//	@Summary		Dictionary Data List
//	@Description	Dictionary Data List
//	@Router			/system/dict/data/list [get]
func (s *SysDictDataController) List(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	query := reqctx.QueryMap(c)
	// 多语言值转key查询
	if v, ok := query["dataLabel"]; ok && v != "" {
		query["dataLabel"] = i18n.TFindKeyPrefix(language, "dictData", v)
	}

	rows, total := s.sysDictDataService.FindByPage(query)

	// 闭包函数处理多语言
	converI18n := func(language string, arr *[]model.SysDictData) {
		for i := range *arr {
			if strings.Contains((*arr)[i].DictType, "i18n") {
				continue
			}
			(*arr)[i].DataLabel = i18n.TKey(language, (*arr)[i].DataLabel)
			(*arr)[i].Remark = i18n.TKey(language, (*arr)[i].Remark)
		}
	}
	converI18n(language, &rows)

	c.JSON(200, resp.OkData(map[string]any{"rows": rows, "total": total}))
}

// Info 字典数据详情
//
// GET /:dataId
func (s SysDictDataController) Info(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	dataId := parse.Number(c.Param("dataId"))
	if dataId <= 0 {
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_CHEACK, "bind err: deptId is empty"))
		return
	}
	data := s.sysDictDataService.FindById(dataId)
	if data.DataId == dataId {
		// 处理多语言
		if !strings.Contains(data.DictType, "i18n") {
			data.DataLabel = i18n.TKey(language, data.DataLabel)
			data.Remark = i18n.TKey(language, data.Remark)
		}
		c.JSON(200, resp.OkData(data))
		return
	}
	c.JSON(200, resp.Err(nil))
}

// Add 字典数据新增
//
// POST /
func (s SysDictDataController) Add(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	var body model.SysDictData
	if err := c.ShouldBindBodyWithJSON(&body); err != nil {
		errMsgs := fmt.Sprintf("bind err: %s", resp.FormatBindError(err))
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_PARSER, errMsgs))
		return
	}
	if body.DataId > 0 {
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_CHEACK, "bind err: dataId not is empty"))
		return
	}

	// 检查字典类型是否存在
	dictType := s.sysDictTypeService.FindByType(body.DictType)
	if dictType.DictType != body.DictType {
		// c.JSON(200, resp.ErrMsg("没有权限访问字典类型数据！"))
		c.JSON(200, resp.ErrMsg(i18n.TKey(language, "dictType.noData")))
		return
	}

	// 检查字典标签唯一
	uniqueLabel := s.sysDictDataService.CheckUniqueTypeByLabel(body.DictType, body.DataLabel, 0)
	if !uniqueLabel {
		// msg := fmt.Sprintf("数据新增【%s】失败，该字典类型下标签名已存在", body.DataLabel)
		msg := i18n.TTemplate(language, "dictType.errLabelExists", map[string]any{"name": body.DataLabel})
		c.JSON(200, resp.ErrMsg(msg))
		return
	}

	// 检查字典键值唯一
	uniqueValue := s.sysDictDataService.CheckUniqueTypeByValue(body.DictType, body.DataValue, 0)
	if !uniqueValue {
		// msg := fmt.Sprintf("数据新增【%s】失败，该字典类型下标签值已存在", body.DataValue)
		msg := i18n.TTemplate(language, "dictType.errLabelExists", map[string]any{"name": body.DataLabel})
		c.JSON(200, resp.ErrMsg(msg))
		return
	}

	body.CreateBy = reqctx.LoginUserToUserName(c)
	insertId := s.sysDictDataService.Insert(body)
	if insertId > 0 {
		c.JSON(200, resp.OkData(insertId))
		return
	}
	c.JSON(200, resp.Err(nil))
}

// Edit 字典类型修改
//
// PUT /
func (s SysDictDataController) Edit(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	var body model.SysDictData
	if err := c.ShouldBindBodyWithJSON(&body); err != nil {
		errMsgs := fmt.Sprintf("bind err: %s", resp.FormatBindError(err))
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_PARSER, errMsgs))
		return
	}
	if body.DataId <= 0 {
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_CHEACK, "bind err: dataId is empty"))
		return
	}

	// 检查字典类型是否存在
	dictType := s.sysDictTypeService.FindByType(body.DictType)
	if dictType.DictType != body.DictType {
		// c.JSON(200, resp.ErrMsg("没有权限访问字典类型数据！"))
		c.JSON(200, resp.ErrMsg(i18n.TKey(language, "dictType.noData")))
		return
	}

	// 检查字典编码是否存在
	dictData := s.sysDictDataService.FindById(body.DataId)
	if dictData.DataId != body.DataId {
		// c.JSON(200, resp.ErrMsg("没有权限访问字典编码数据！"))
		c.JSON(200, resp.ErrMsg(i18n.TKey(language, "dictData.noData")))
		return
	}

	// 检查字典标签唯一
	uniqueLabel := s.sysDictDataService.CheckUniqueTypeByLabel(body.DictType, body.DataLabel, body.DataId)
	if !uniqueLabel {
		// msg := fmt.Sprintf("数据修改【%s】失败，该字典类型下标签名已存在", body.DataLabel)
		msg := i18n.TTemplate(language, "dictType.errLabelExists", map[string]any{"name": body.DataLabel})
		c.JSON(200, resp.ErrMsg(msg))
		return
	}

	// 检查字典键值唯一
	uniqueValue := s.sysDictDataService.CheckUniqueTypeByValue(body.DictType, body.DataValue, body.DataId)
	if !uniqueValue {
		// msg := fmt.Sprintf("数据修改【%s】失败，该字典类型下标签值已存在", body.DataLabel)
		msg := i18n.TTemplate(language, "dictType.errLabelExists", map[string]any{"name": body.DataLabel})
		c.JSON(200, resp.ErrMsg(msg))
		return
	}

	// 多语言非原始值
	i18nValue := i18n.TKey(language, dictData.DataLabel)
	if i18nValue != dictData.DataLabel {
		service.NewSysI18n.UpdateKeyValue(language, dictData.DataLabel, body.DataLabel)
		body.DataLabel = dictData.DataLabel
	}
	// 多语言非原始值
	i18nValue2 := i18n.TKey(language, dictData.Remark)
	if i18nValue2 != dictData.Remark {
		service.NewSysI18n.UpdateKeyValue(language, dictData.Remark, body.Remark)
		body.Remark = dictData.Remark
	}

	dictData.DictType = body.DictType
	dictData.DataLabel = body.DataLabel
	dictData.DataValue = body.DataValue
	dictData.DataSort = body.DataSort
	dictData.TagClass = body.TagClass
	dictData.TagType = body.TagType
	dictData.StatusFlag = body.StatusFlag
	dictData.Remark = body.Remark
	dictData.UpdateBy = reqctx.LoginUserToUserName(c)
	rows := s.sysDictDataService.Update(dictData)
	if rows > 0 {
		c.JSON(200, resp.Ok(nil))
		return
	}
	c.JSON(200, resp.Err(nil))
}

// Remove 字典数据删除
//
// DELETE /:dataId
func (s SysDictDataController) Remove(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	dataId := c.Param("dataId")
	if dataId == "" {
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_CHEACK, "bind err: dataId is empty"))
		return
	}

	// 处理字符转id数组后去重
	uniqueIDs := parse.RemoveDuplicatesToArray(dataId, ",")
	// 转换成int64数组类型
	ids := make([]int64, 0)
	for _, v := range uniqueIDs {
		ids = append(ids, parse.Number(v))
	}

	rows, err := s.sysDictDataService.DeleteByIds(ids)
	if err != nil {
		c.JSON(200, resp.ErrMsg(err.Error()))
		return
	}
	// msg := fmt.Sprintf("删除成功：%d", rows)
	msg := i18n.TTemplate(language, "app.common.deleteSuccess", map[string]any{"num": rows})
	c.JSON(200, resp.OkMsg(msg))
}

// DictType 字典数据列表（指定字典类型）
//
// GET /type/:dictType
func (s SysDictDataController) DictType(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	dictType := c.Param("dictType")
	if dictType == "" {
		c.JSON(422, resp.CodeMsg(resp.CODE_PARAM_CHEACK, "bind err: dictType is empty"))
		return
	}

	data := s.sysDictDataService.FindByType(dictType)

	// 闭包函数处理多语言
	converI18n := func(language string, arr *[]model.SysDictData) {
		for i := range *arr {
			(*arr)[i].DataLabel = i18n.TKey(language, (*arr)[i].DataLabel)
			(*arr)[i].Remark = i18n.TKey(language, (*arr)[i].Remark)
		}
	}
	converI18n(language, &data)

	c.JSON(200, resp.OkData(data))
}

// Export 字典数据列表导出
//
// GET /export
func (s SysDictDataController) Export(c *gin.Context) {
	language := reqctx.AcceptLanguage(c)
	// 查询结果，根据查询条件结果，单页最大值限制
	query := reqctx.QueryMap(c)
	rows, total := s.sysDictDataService.FindByPage(query)
	if total == 0 {
		// c.JSON(200, resp.CodeMsg(40016, "export data record as empty"))
		c.JSON(200, resp.ErrMsg(i18n.TKey(language, "app.common.exportEmpty")))
		return
	}

	// 闭包函数处理多语言
	converI18n := func(language string, arr *[]model.SysDictData) {
		for i := range *arr {
			if strings.Contains((*arr)[i].DictType, "i18n") {
				continue
			}
			(*arr)[i].DataLabel = i18n.TKey(language, (*arr)[i].DataLabel)
			(*arr)[i].Remark = i18n.TKey(language, (*arr)[i].Remark)
		}
	}
	converI18n(language, &rows)

	// 导出文件名称
	fileName := fmt.Sprintf("dict_data_export_%d_%d.xlsx", len(rows), time.Now().UnixMilli())
	// 第一行表头标题
	headerCells := map[string]string{
		"A1": i18n.TKey(language, "dictData.export.code"),
		"B1": i18n.TKey(language, "dictData.export.label"),
		"C1": i18n.TKey(language, "dictData.export.value"),
		"D1": i18n.TKey(language, "dictData.export.sort"),
		"E1": i18n.TKey(language, "dictData.export.status"),
	}
	// 从第二行开始的数据
	dataCells := make([]map[string]any, 0)
	for i, row := range rows {
		idx := strconv.Itoa(i + 2)
		statusValue := i18n.TKey(language, "dictData.disable")
		if row.StatusFlag == "1" {
			statusValue = i18n.TKey(language, "dictData.normal")
		}
		dataCells = append(dataCells, map[string]any{
			"A" + idx: row.DataId,
			"B" + idx: row.DataLabel,
			"C" + idx: row.DataValue,
			"D" + idx: row.DataSort,
			"E" + idx: statusValue,
		})
	}

	// 导出数据表格
	saveFilePath, err := file.WriteSheet(headerCells, dataCells, fileName, "")
	if err != nil {
		c.JSON(200, resp.ErrMsg(err.Error()))
		return
	}

	c.FileAttachment(saveFilePath, fileName)
}
